#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var get_port_1 = __importDefault(require("get-port"));
var meow_1 = __importDefault(require("meow"));
var minimist_1 = __importDefault(require("minimist"));
var ora_1 = __importDefault(require("ora"));
var path_1 = __importDefault(require("path"));
var bundle_1 = require("./bundle");
var fs_1 = require("./fs");
var plugins_1 = require("./plugins");
var puppeteer_1 = require("./puppeteer");
var server_1 = require("./server");
var temporary_1 = require("./temporary");
var cli = meow_1.default("\n  Usage\n    $ puppet-run <./entrypoint> [...more entrypoints] [-- <...script arguments>]\n    $ puppet-run <./entrypoint>:</serve/here> [...more entrypoints] [-- <...script args>]\n    $ puppet-run --plugin=<plugin> [<...entrypoints>] [-- <...script arguments>]\n\n  Options\n    --help                            Show this help.\n    --inspect                         Run in actual Chrome window and keep it open.\n    --bundle <./file>[:</serve/here>] Bundle and serve additional files, but don't inject them.\n    --p <port>, --port <port>         Serve on this port. Defaults to random port.\n    --plugin <plugin>                 Load and apply plugin <plugin>.\n    --serve <./file>[:</serve/here>]  Serve additional files next to bundle.\n\n  Example\n    $ puppet-run ./sample/cowsays.js\n    $ puppet-run ./sample/greet.ts newbie\n    $ puppet-run --plugin=mocha ./sample/mocha-test.ts\n", {
    autoHelp: false
});
function ensureArray(arg) {
    if (!arg) {
        return [];
    }
    else if (Array.isArray(arg)) {
        return arg;
    }
    else {
        return [arg];
    }
}
function parseEntrypointArg(arg) {
    var _a = __read(arg.split(":"), 2), sourcePath = _a[0], servePath = _a[1];
    return {
        servePath: servePath,
        sourcePath: sourcePath
    };
}
function withSpinner(promise) {
    return __awaiter(this, void 0, void 0, function () {
        var spinner, result, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    spinner = ora_1.default("Bundling code").start();
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, promise];
                case 2:
                    result = _a.sent();
                    spinner.succeed("Bundling done.");
                    return [2 /*return*/, result];
                case 3:
                    error_1 = _a.sent();
                    spinner.fail("Bundling failed.");
                    throw error_1; // re-throw
                case 4: return [2 /*return*/];
            }
        });
    });
}
var argsSeparatorIndex = process.argv.indexOf("--");
var runnerOptionArgs = argsSeparatorIndex > -1 ? process.argv.slice(2, argsSeparatorIndex) : process.argv.slice(2);
var scriptArgs = argsSeparatorIndex > -1 ? process.argv.slice(argsSeparatorIndex + 1) : [];
var runnerOptions = minimist_1.default(runnerOptionArgs);
var pluginNames = Array.isArray(runnerOptions.plugin || [])
    ? runnerOptions.plugin || []
    : [runnerOptions.plugin];
var plugins = pluginNames.map(plugins_1.loadPlugin);
if (runnerOptionArgs.indexOf("--help") > -1 && plugins.length > 0) {
    plugins_1.printPluginHelp(plugins[0], scriptArgs);
    process.exit(0);
}
else if (process.argv.length === 2 || runnerOptionArgs.indexOf("--help") > -1) {
    cli.showHelp();
    process.exit(0);
}
function run() {
    return __awaiter(this, void 0, void 0, function () {
        var exitCode, headless, port, _a, additionalBundleEntries, additionalFilesToServe, entrypointArgs, entrypoints, temporaryCache, serverURL, allBundles, startupBundles, lazyBundles, closeServer, puppet, error_2;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    exitCode = 0;
                    headless = runnerOptionArgs.indexOf("--inspect") > -1 ? false : true;
                    if (!(runnerOptions.p || runnerOptions.port)) return [3 /*break*/, 1];
                    _a = parseInt(runnerOptions.p || runnerOptions.port, 10);
                    return [3 /*break*/, 3];
                case 1: return [4 /*yield*/, get_port_1.default()];
                case 2:
                    _a = _b.sent();
                    _b.label = 3;
                case 3:
                    port = _a;
                    return [4 /*yield*/, fs_1.resolveDirectoryEntrypoints(ensureArray(runnerOptions.bundle).map(parseEntrypointArg), function (filenames) { return fs_1.dedupeSourceFiles(filenames, true); })];
                case 4:
                    additionalBundleEntries = _b.sent();
                    return [4 /*yield*/, fs_1.resolveDirectoryEntrypoints(ensureArray(runnerOptions.serve).map(parseEntrypointArg))];
                case 5:
                    additionalFilesToServe = _b.sent();
                    entrypointArgs = runnerOptions._;
                    return [4 /*yield*/, plugins_1.resolveEntrypoints(plugins, entrypointArgs.map(parseEntrypointArg), scriptArgs)];
                case 6:
                    entrypoints = _b.sent();
                    temporaryCache = temporary_1.createTemporaryFileCache();
                    _b.label = 7;
                case 7:
                    _b.trys.push([7, 15, 19, 20]);
                    serverURL = "http://localhost:" + port + "/";
                    temporary_1.writeBlankHtmlPage(path_1.default.join(temporaryCache, "index.html"));
                    return [4 /*yield*/, withSpinner(Promise.all(__spread(entrypoints, additionalBundleEntries).map(function (entrypoint) {
                            return bundle_1.createBundle(entrypoint, temporaryCache);
                        })))];
                case 8:
                    allBundles = _b.sent();
                    startupBundles = allBundles.slice(0, entrypoints.length);
                    lazyBundles = allBundles.slice(entrypoints.length);
                    return [4 /*yield*/, fs_1.copyFiles(__spread(additionalFilesToServe, lazyBundles), temporaryCache)];
                case 9:
                    _b.sent();
                    return [4 /*yield*/, server_1.serveDirectory(temporaryCache, port)];
                case 10:
                    closeServer = _b.sent();
                    return [4 /*yield*/, puppeteer_1.spawnPuppet(startupBundles.map(function (entry) { return entry.servePath; }), serverURL, { headless: headless })];
                case 11:
                    puppet = _b.sent();
                    return [4 /*yield*/, puppet.run(scriptArgs, plugins)];
                case 12:
                    _b.sent();
                    return [4 /*yield*/, puppet.waitForExit()];
                case 13:
                    exitCode = _b.sent();
                    return [4 /*yield*/, puppet.close()];
                case 14:
                    _b.sent();
                    closeServer();
                    return [3 /*break*/, 20];
                case 15:
                    error_2 = _b.sent();
                    if (!headless) return [3 /*break*/, 16];
                    throw error_2;
                case 16:
                    // tslint:disable-next-line:no-console
                    console.error(error_2);
                    return [4 /*yield*/, new Promise(function (resolve) { return process.on("SIGINT", resolve); })];
                case 17:
                    _b.sent();
                    _b.label = 18;
                case 18: return [3 /*break*/, 20];
                case 19:
                    if (process.env.KEEP_TEMP_CACHE) {
                        // tslint:disable-next-line:no-console
                        console.log("Temporary cache written to: " + temporaryCache);
                    }
                    else {
                        temporary_1.clearTemporaryFileCache(temporaryCache);
                    }
                    return [7 /*endfinally*/];
                case 20:
                    if (exitCode > 0) {
                        // tslint:disable-next-line:no-console
                        console.log("Script exited with exit code " + exitCode + ".");
                    }
                    process.exit(exitCode);
                    return [2 /*return*/];
            }
        });
    });
}
run().catch(function (error) {
    // tslint:disable-next-line:no-console
    console.error(error);
    process.exit(1);
});
