"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.subscribeToMagicLogs = exports.injectPuppetContext = exports.createPuppetContextConfig = exports.captureFailedRequests = exports.capturePuppetConsole = void 0;
// tslint:disable:no-console
var chalk_1 = __importDefault(require("chalk"));
var magicLogMessageMarker = "$$$PUPPET_MAGIC_LOG$$$";
function consoleMessageToLogArgs(message) {
    return __awaiter(this, void 0, void 0, function () {
        var args, jsonArgs;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    args = message.args();
                    return [4 /*yield*/, Promise.all(args.map(function (arg) { return arg.jsonValue(); }))
                        // Clean-up to enable garbage collection
                    ];
                case 1:
                    jsonArgs = _a.sent();
                    // Clean-up to enable garbage collection
                    args.forEach(function (arg) { return arg.dispose(); });
                    return [2 /*return*/, jsonArgs];
            }
        });
    });
}
function capturePuppetConsole(page) {
    var _this = this;
    page.on("console", function (message) { return __awaiter(_this, void 0, void 0, function () {
        var type, consoleArgs;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    type = message.type();
                    // Ignore magic messages, since they are control messages
                    if (message.text().startsWith(magicLogMessageMarker))
                        return [2 /*return*/];
                    return [4 /*yield*/, consoleMessageToLogArgs(message)];
                case 1:
                    consoleArgs = _a.sent();
                    if (type === "clear") {
                        return [2 /*return*/, console.clear()];
                    }
                    else if (type === "startGroupCollapsed") {
                        return [2 /*return*/, console.groupCollapsed()];
                    }
                    else if (type === "endGroup") {
                        return [2 /*return*/, console.groupEnd()];
                    }
                    if (type === "error") {
                        console.error.apply(console, __spread(consoleArgs));
                    }
                    else if (type === "warning") {
                        console.warn.apply(console, __spread(consoleArgs));
                    }
                    else if (type === "debug") {
                        console.debug.apply(console, __spread(consoleArgs));
                    }
                    else if (type === "startGroup") {
                        console.group.apply(console, __spread(consoleArgs));
                    }
                    else {
                        console.log.apply(console, __spread(consoleArgs));
                    }
                    return [2 /*return*/];
            }
        });
    }); });
}
exports.capturePuppetConsole = capturePuppetConsole;
function captureFailedRequests(page) {
    page.on("requestfailed", function (request) {
        var failure = request.failure();
        console.error(chalk_1.default.redBright("Request failed: " + request.method() + " " + request.url()));
        console.error(chalk_1.default.gray("  " + (failure ? failure.errorText : "Unknown error")));
    });
    page.on("requestfinished", function (request) {
        var response = request.response();
        if (response && response.status() >= 400) {
            console.error(chalk_1.default.redBright("HTTP " + response.status() + " " + request.method() + " " + request.url()));
        }
    });
}
exports.captureFailedRequests = captureFailedRequests;
function createPuppetContextConfig(argv, plugins) {
    if (plugins === void 0) { plugins = {}; }
    return {
        argv: argv,
        plugins: plugins
    };
}
exports.createPuppetContextConfig = createPuppetContextConfig;
function injectPuppetContext(page, contextConfig) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, page.addScriptTag({
                        content: "\n      window.puppet = {\n        argv: " + JSON.stringify(contextConfig.argv) + ",\n        plugins: " + JSON.stringify(contextConfig.plugins) + ",\n        exit (exitCode = 0) {\n          console.log(" + JSON.stringify(magicLogMessageMarker) + ", \"exit\", exitCode)\n        },\n        setOfflineMode (offline = true) {\n          return window.setPuppetOfflineMode(offline)\n        }\n      };\n    "
                    })];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, page.exposeFunction("setPuppetOfflineMode", function (offlineMode) { return page.setOfflineMode(offlineMode); })];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.injectPuppetContext = injectPuppetContext;
function subscribeToMagicLogs(page, subscriber) {
    var _this = this;
    var handler = function (message) { return __awaiter(_this, void 0, void 0, function () {
        var args, firstArgument, _a, type, otherArgs;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    args = message.args();
                    if (args.length < 2)
                        return [2 /*return*/];
                    return [4 /*yield*/, args[0].jsonValue()];
                case 1:
                    firstArgument = _b.sent();
                    if (firstArgument !== magicLogMessageMarker)
                        return [2 /*return*/];
                    return [4 /*yield*/, Promise.all(args.slice(1).map(function (arg) { return arg.jsonValue(); }))
                        // Don't forget to dispose eventually, to enable garbage collection of log message args
                    ];
                case 2:
                    _a = __read.apply(void 0, [_b.sent()
                        // Don't forget to dispose eventually, to enable garbage collection of log message args
                    ]), type = _a[0], otherArgs = _a.slice(1);
                    // Don't forget to dispose eventually, to enable garbage collection of log message args
                    args.forEach(function (arg) { return arg.dispose(); });
                    subscriber(type, otherArgs);
                    return [2 /*return*/];
            }
        });
    }); };
    page.on("console", handler);
    var unsubscribe = function () { return page.off("console", handler); };
    return unsubscribe;
}
exports.subscribeToMagicLogs = subscribeToMagicLogs;
